/**********************************************
* PIC24FJ32GA002 t@~ 
*  NTSCrfIo̓Cu@@@Video.c
**********************************************/
#include "p24FJ32GA002.h"
#include "NTSC.h"
#include "font8.h"
///// f[^錾`
#define SV_PREEQ	0					// vEQ
#define SV_SYNC		1					// 
#define SV_POSTEQ	2					// |XgEQ
#define	SV_LINE		3					// f\
///// pX萔
#define V_NTSC		262					// 262{///
#define V_SYNC		13					// {13
#define V_BLANK		(V_NTSC - V_RES - V_SYNC)
#define V_PREEQ		V_BLANK / 2			// uLOԏ㑤
#define V_POSTEQ	V_BLANK - V_PREEQ	// uLOԉ
#define H_NTSC		1016				// 63.5usec Tcy1016
#define H_SYNC		75					// 4.7usec Tcy75
#define H_BACK		111					// 4.7usec Tcy111
///// ϐ`
volatile unsigned int *VPtr, *MPtr;		// VRAM֘A|C^
volatile unsigned int  VCount, VState, DotCount;
//// Xe[gXVp萔`
unsigned char VS[4] = {SV_SYNC, SV_POSTEQ, SV_LINE, SV_PREEQ};
unsigned char VC[4] = {V_SYNC, V_POSTEQ, V_RES, V_PREEQ};
/// \W
int cx, cy;
//// VRAM rfI̒`	256*192/8=6144byte
unsigned int __attribute__((far)) VMem[V_RES * (H_RES/16)];
/// n[hEFAݒ I/Os`
#define SYNC	LATBbits.LATB5			//@Mo
#define VIDEO	LATBbits.LATB4			// fMo

/*********************************************
* ֐
*********************************************/
void VideoInit(void){
	int i;

	/// ^C}2̏ݒ,NbN63.5usecA1:1
	T2CON = 0x0000;				// ^C}R~
	PR2 = H_NTSC - 1; 			// 63.5usec
	IPC1bits.T2IP = 4;			// ^C}R荞ݗL
	IFS0bits.T2IF = 0;
	IEC0bits.T2IE = 1;
	/// SPI1̏ݒ
	SPI1CON1 = 0x0437;			// }X^A16rbgASCK/SSȂA1:3
	SPI1CON2 = 0;				// t[Ȃ
	SPI1STAT = 0x8000;			// SPI|[gL
	IPC2bits.SPI1IP = 4;
	IFS0bits.SPI1IF = 0;
	IEC0bits.SPI1IE = 1;
	/// OC1̊荞ݗL
	IPC0bits.OC1IP = 4;			// 荞݃x
	IFS0bits.OC1IF = 0;
	IEC0bits.OC1IE = 1;
	/// OC2̊荞ݗL
	IPC1bits.OC2IP = 4;			// 荞݃x
	IFS0bits.OC2IF = 0;
	IEC0bits.OC2IE = 1;
	/// ϐݒ
	VState = 0;					// Xe[g}V
	VCount = V_PREEQ;			// CJE^lZbg
	//// VRAM
	VPtr = VMem;
	for(i=0; i<3072; i++){		// Œp^[ݒ
		*VPtr = 0;
		VPtr++;
	}
	VPtr = VMem;				// rfI|C^
	T2CONbits.TON = 1;			// Ń^C}2X^[g
}

/******************************************
*  NTSCrfIM֐
*******************************************/
/**********************
*  Timer2 荞ݏ֐
***********************/
void __attribute__((interrupt,__no_auto_psv__, __shadow__)) _T2Interrupt(void)
{
	SYNC = 0;						// o(RB10)
	VCount--;						// JE^XV
	// Xe[gɂ蕪
	switch(VState)
	{
		case SV_PREEQ:				// uLO㑤̋
			OC1R = H_SYNC - 5;		// pX4.7usec
			OC1CON = 0x0001;		// ^C}2IVbg@L->H
			break;
		case SV_SYNC:				// Ԓ
			OC1R = H_NTSC-H_SYNC-5;	// ؂ꍞ݃pX
			OC1CON = 0x0001;
			break;
		case SV_POSTEQ:				// uLŐ					
			OC1R = H_SYNC - 5;		// pX4.7usec
			OC1CON = 0x0001;		// ^C}2IVbg@L->H
			if(VCount == 0){		// t[IH
				VPtr = VMem;		// t[̍ŏɍăZbg
			}
			break;
		default:
		case SV_LINE:				// f\
			OC1R = H_SYNC - 5;		// ␳5Tcy
			OC1CON = 0x0001;		// ^C}2IVbg@L->H
			OC2R = H_SYNC + H_BACK;	// fJn܂ł̒x
			OC2CON = 0x0001;		// ^C}2IVbg@L->H
			break;
	}
	//// JE^XV
	if(VCount == 0){				// Xe[gIH
		VCount = VC[VState];		// CJE^XV
		VState = VS[VState];		// Xe[gXV
	}
	IFS0bits.T2IF = 0;				// T2荞݃tONA
}

/*********************
*  OC1荞ݏ֐
*********************/
void __attribute__((interrupt,no_auto_psv, shadow)) _OC1Interrupt(void)
{
	SYNC = 1;						// pXZbg
	IFS0bits.OC1IF = 0;				// 荞݃tONA
}
/***********************
*  OC2荞ݏ֐
***********************/
void __attribute__((interrupt,no_auto_psv, shadow)) _OC2Interrupt(void)
{
	//// rfIMo
	SPI1BUF = *VPtr++;				// ŏSPI[ho͂𒼂o
	IFS0bits.OC2IF = 0;				// 荞݃tONA
	DotCount = 0;
	while(SPI1STATbits.SPITBF);		// fB[҂
	SPI1BUF = *VPtr++;				// 2ԖڂSPIf[^o
}
/**************************
*  SPI1荞ݏ
**************************/
void __attribute__((interrupt, no_auto_psv, shadow)) _SPI1Interrupt(void)
{
	int dumy;
	if(DotCount <= 13){
		SPI1BUF = *VPtr++;			// o͎s(16[h)
		DotCount++;					// hbgJE^XV
	}
	dumy = SPI1BUF;					// _~[[h
	IFS0bits.SPI1IF = 0;			// 荞݃tONA
}


/*****************************
* iwAxj_`֐
******************************/
void Plot(unsigned x, unsigned y)
{
	/// W͈͓łΓ_`
	if((x < H_RES) && (y < V_RES))
		/// [hPʂŃrbgʒuvZ@ɂPZbg
		VMem[((V_RES-1-y)<<4) + (x>>4)] |= (0x8000 >> (x & 0x0F));
}

/****************************
*  `֐	
****************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void line(int x0, int y0, int x1, int y1)
{
	int steep, t;
	int	deltax, deltay, error;
	int x, y;
	int ystep;
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;				// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;
	/// _ŕ`
	for(x=x0; x<x1; x++) {
		if(steep) Plot(y,x); else Plot(x,y);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}
/************************************
*  XW⏕@_\
************************************/
void dotxline(int y0)
{
	int i;

	for(i=0; i<H_RES; i+=3)
		Plot(i, y0-1);
}
/***********************************
*  YW⏕@_\
***********************************/
void dotyline(int x0){
	int i;

	for(i=0; i<V_RES; i+=3)
		Plot(x0-1, i);
}	
/***********************************
*  `֐
***********************************/
void putcV( int a)
{
    unsigned int i, *p;
    const unsigned char *pf;
	/// R[h͈̔̓`FbN
    a -= F_OFFS;
    if (a < 0)         a = 0;
    if (a >= F_SIZE)   a = F_SIZE-1; 
 	/// y[W̐܂Ԃ`FbN
    if (cx >= H_RES/8){         // E[܂Ԃ
        cx = 0;	cy++;   
    } 
    if (cy >= V_RES/8)			// [܂Ԃ
        cy = 0;
	/// rfI\ʒu|C^[Zbg([hP)
    p = &VMem[cy*8 * H_RES/16 + cx/2];
    /// tHgf[^o|C^i[hPʁj
	pf = &Font8[a << 3];		// 8{
	/// \
    for (i=0; i<8; i++){
        if ( cx & 1) {			// ʃoCĝƂ
            *p &= 0xff00;
            *p |= (int)(*pf++);
        } 
        else {					// ʃoCĝƂ
            *p &= 0x00ff;
            *p |= (int)(*pf++)<<8;
		}   
        p += H_RES/16;			// ̃C 
	}
    cx++;						// J[\ʒuXV
}
/******************************
*   `֐
******************************/
void putsV(const unsigned char *s)
{
    while (*s)
        putcV(*s++);
}

